<?php

/**
 * mod_smenu_position
 *
 * @version 2.0
 * @author Creative Pulse
 * @copyright Creative Pulse 2009
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @link http://www.creativepulse.eu
 */

defined('_JEXEC') or die('Restricted access');

if (!$mod->loadit)
	return;


if ($mod->instance_id() == 1)
	echo '
<script type="text/javascript" src="modules/mod_smenu_position/smenu.js"></script>
<script type="text/javascript">
// <![CDATA[

function smenu_position_init() {
	for (var k in document["mod_smenu_position_conf"])
		if (document["mod_smenu_position_conf"].hasOwnProperty(k)) {
			var conf = document["mod_smenu_position_conf"][k];

			var node = document.getElementById(conf.posname);
			if (node)
				node = node.firstChild;

			if (node) {
				document[conf.iname] = new Smenu(conf.iname, conf.host_id);
				document[conf.iname].init(conf.vars);

				if (conf.img_start != null)
					document[conf.iname].add_item(conf.img_start);

				var tab_idx = -1;
				while (node) {
					if (node.nodeType == 1) {
						// if the node is a regular DOM element, handle it as a data source


						// try to find and remove header

						var header = node.firstChild;
						while (header && header.nodeType != 1)
							header = header.nextSibling;

						if (header && header.tagName == "H3")
							header.parentNode.removeChild(header);


						// cache next data block
						var content_node = node;
						node = node.nextSibling;


						tab_idx++;

						// add splitter
						if (tab_idx > 0 && tab_idx - 1 < conf.img_split_list.length)
							document[conf.iname].add_item(conf.img_split_list[tab_idx - 1]);

						// add data block to smenu
						content_node.id = conf.iname + "_" + tab_idx;

						var params = {html_srcid: content_node.id};

						if (tab_idx < conf.outer_class_norm_list.length)
							params.outer_class_norm = conf.outer_class_norm_list[tab_idx];

						if (tab_idx < conf.outer_class_sel_list.length)
							params.outer_class_sel = conf.outer_class_sel_list[tab_idx];

						if (tab_idx < conf.outer_class_norm_list.length)
							params.inner_class_norm = conf.outer_class_norm_list[tab_idx];

						if (tab_idx < conf.inner_class_sel_list.length)
							params.inner_class_sel = conf.inner_class_sel_list[tab_idx];

						document[conf.iname].add_item(params);
					}
					else {
						// move to the next data block
						node = node.nextSibling;
					}
				}

				if (conf.img_end != null)
					document[conf.iname].add_item(conf.img_end);

				document[conf.iname].runit();
			}
		}
}

if (window.addEventListener)
	window.addEventListener("load", smenu_position_init, false);
else if (window.attachEvent)
	window.attachEvent("onload", smenu_position_init);

// ]]>
</script>
';

$outer_class_norm_list = '';
if (!empty($mod->outer_class_norm_list)) {
	$outer_class_norm_list = array();
	foreach ($mod->outer_class_norm_list as $v)
		$outer_class_norm_list[] = '"' . $mod->json_esc($v) . '"';
	$outer_class_norm_list = implode(', ', $outer_class_norm_list);
}

$outer_class_sel_list = '';
if (!empty($mod->outer_class_sel_list)) {
	$outer_class_sel_list = array();
	foreach ($mod->outer_class_sel_list as $v)
		$outer_class_sel_list[] = '"' . $mod->json_esc($v) . '"';
	$outer_class_sel_list = implode(', ', $outer_class_sel_list);
}

$inner_class_norm_list = '';
if (!empty($mod->inner_class_norm_list)) {
	$inner_class_norm_list = array();
	foreach ($mod->inner_class_norm_list as $v)
		$inner_class_norm_list[] = '"' . $mod->json_esc($v) . '"';
	$inner_class_norm_list = implode(', ', $inner_class_norm_list);
}

$inner_class_sel_list = '';
if (!empty($mod->inner_class_sel_list)) {
	$inner_class_sel_list = array();
	foreach ($mod->inner_class_sel_list as $v)
		$inner_class_sel_list[] = '"' . $mod->json_esc($v) . '"';
	$inner_class_sel_list = implode(', ', $inner_class_sel_list);
}

echo '
<div id="mod_smenu_position_' . $mod->instance_id() . '"' . $mod->div_str . '></div>

<script type="text/javascript">
// <![CDATA[
if (!document["mod_smenu_position_conf"])
	document["mod_smenu_position_conf"] = { }

document["mod_smenu_position_conf"]["inst_' . $mod->instance_id() . '"] = {
	iname: "smenu_position_' . $mod->instance_id() . '",
	host_id: "mod_smenu_position_' . $mod->instance_id() . '",
	posname: "' . $mod->posname . '",
	vars: {
		interval: ' . $mod->interval . ',
		speed: ' . $mod->speed . ',
		minstep: ' . $mod->minstep . ',
		maxstep: ' . $mod->maxstep . ',
		hor: ' . $mod->hor . ',
		align: ' . $mod->align . ',
		movtype: "' . $mod->movtype . '",
		anitype: "' . $mod->anitype . '",
		min_size: ' . $mod->min_size . ',
		large_size: ' . $mod->large_size . ',
		padding: ' . $mod->padding . ',
' . $mod->def_classes . '
		sel_permanent: ' . $mod->sel_permanent . ',
		def_item: ' . $mod->def_item . '
	},
	img_start: ' . ($mod->img_start == '' ? 'null' : $mod->img_start) .  ',
	img_end: ' . ($mod->img_end == '' ? 'null' : $mod->img_end) .  ',
	img_split: ' . ($mod->def_split_image == '' ? 'null' : $mod->def_split_image) . ',
	img_split_list: [
		' . (empty($mod->split_image_list) ? '' : implode(",\n		", $mod->split_image_list)) . '
	],
	outer_class_norm_list: [' . $outer_class_norm_list . '],
	outer_class_sel_list: [' . $outer_class_sel_list . '],
	inner_class_norm_list: [' . $inner_class_norm_list . '],
	inner_class_sel_list: [' . $inner_class_sel_list . ']
}

// ]]>
</script>
';

?>