<?php

/**
 * Promote - Joomla Template
 *
 * @package bt_promote
 * @version 1.0
 * @copyright BonusThemes.com 2009
 * @link http://www.bonusthemes.com/goto/bt_promote
 */

defined( '_JEXEC' ) or die( 'Restricted access' );


class TplBtPromote {

	var $width = 960;

	var $btlogo = 'on';

	var $header_menu = 'menu';
	var $header_menu_name = 'topmenu';

	var $seocp = 'off';

	var $cnt_menus = 'on';
	var $virtuemart = 'on';

	var $blogstyle = '';

	var $mod_word = 'on';

	function TplBtPromote() {
		$this->__construct();
	}

	function __construct() {
		$this->document =& JFactory::getDocument();

		$this->prepare_parameters();
		$this->prepare_path();

		$this->lshow = strtolower($this->btlogo) == 'on';

		$this->show_body = $this->show_body();

		$this->seocp = $this->show_body && strtolower($this->seocp) == 'on';

		$this->cnt_menus = strtolower($this->cnt_menus) == 'on';
		$this->virtuemart = strtolower($this->virtuemart) == 'on';

		$this->mod_word = strtolower($this->mod_word) == 'on';


		$this->main_area_visible = $this->show_body()
			|| $this->modcount('ad1') || $this->modcount('ad2') || $this->modcount('ad3') || $this->modcount('ad4')
			|| $this->modcount('bottom1') || $this->modcount('bottom2') || $this->modcount('bottom3') || $this->modcount('bottom4');


		// load styles
		require(dirname(__FILE__) . '/zl_styles.php');
		$this->mstyles = $mstyles;

		$this->show_menu = $this->header_menu == 'menu';

		if ($this->show_menu)
			$this->load_menu($this->header_menu_name, $this->menu_head_tags, $this->menu_js);
	}

	function str($str) {
		return JText::_($str);
	}

	function show_body() {
		return JRequest::getCmd('option') != 'com_nb';
	}

	function get_home() {
		return $this->document->baseurl;
	}

	function prepare_parameters() {
		$app = JFactory::getApplication(); //j17
		$tmpl_params = $app->getTemplate(true)->params; //j17
		
		//j17
		$this->width = $tmpl_params->get('width');
		$this->pos_widths = $tmpl_params->get('pos_widths');
		$this->header_menu = $tmpl_params->get('header_menu');
		$this->header_menu_name = $tmpl_params->get('header_menu_name');		
		$this->cnt_menus = $tmpl_params->get('cnt_menus');
		$this->btlogo = $tmpl_params->get('btlogo');
		$this->mod_word = $tmpl_params->get('mod_word');
		
		$lines = explode("\n", str_replace("\r", '', $this->pos_widths));
		foreach ($lines as $line) {
			$e = explode(':', $line, 2);
			$k = strtolower(trim(@$e[0]));
			$v = trim(@$e[1]);
			if (preg_match('/^[a-z0-9_]+$/', $k) && ctype_digit($v)) {
				if ($k == 'mainbody')
					$k .= '_width';
				else
					$k = 'pos_' . $k . '_width';

				$this->$k = $v;
			}
		}
	}

	function prepare_path() {
		$this->path = $this->document->baseurl . '/templates/' . $this->document->template;
	}

	function modcount($position_name) {
		static $modules = array();

		if (!isset($modules[$position_name]))
			$modules[$position_name] = $this->document->countModules($position_name);

		return $modules[$position_name];
	}

	function td_width($position_name, $shrink = false) {
		if (is_array($position_name)) {
			$max = 0;
			foreach ($position_name as $name) {
				$k = 'pos_' . $name . '_width';
				if (isset($this->$k) && intval($this->$k) > $max)
					$max = intval($this->$k);
			}

			if ($max > 0)
				return ' width="' . $max . '"';
		}
		else {
			$k = 'pos_' . $position_name . '_width';
			if (isset($this->$k))
				return ' width="' . $this->$k . '"';
		}

		if ($shrink)
			return ' width="1%" nowrap="nowrap"';
		else
			return '';
	}

	function get_hidden_position($position_name) {
		$result = '';
		if ($this->modcount($position_name))
			$result =
'<div id="pos_' . $position_name . '" style="display:none">
	<jdoc:include type="modules" name="' . $position_name . '" style="xhtml" />
</div>';

		return $result;
	}

	function get_pathway() {
		return '<jdoc:include type="modules" name="breadcrumb" />' . "\n";
	}

	function get_message() {
		return '<jdoc:include type="message" />' . "\n";
	}

	function get_mainbody_pragma() {
		$var = 'mainbody_width';
		return
'<div id="mainbody"' . (isset($this->$var) && !empty($this->$var) ? ' style="width:' . $this->$var . 'px"' : '') . '>
<jdoc:include type="component" />
</div>
';
	}

	function get_mainbody_wrapper() {
		if (!$this->show_body)
			return '';

		$result = $this->seocp ? '<div id="mainbody_area"></div>' . "\n" : $this->get_mainbody_pragma();
		$result .= '<div class="clearfix"></div>' . "\n"; // fix for IE7
		return $result;
	}

	function get_debug() {
		return '<div style="display:none">#fc3424 #5835a1 #1975f2 #1964ee #e40c1f #86a7c4</div>' . $this->get_position('debug');
	}

	function get_position($position_name, $direct = false, $clearfix = true) {
		$result = '';
		if ($direct || $this->modcount($position_name)) {
			$width = '';
			$var = 'pos_' . $position_name . '_width';
			if (isset($this->$var) && !empty($this->$var))
				$width = $this->$var;

			$result .= sprintf(
				'<div id="pos_%s"%s>' . "\n",
				$position_name,
				empty($width) ? '' : ' style="width:' . $width . 'px"'
			);
			$result .= '	<jdoc:include type="modules" name="' . $position_name . '" style="zlmod" />' . "\n";
			$result .= '</div>' . "\n";

			if ($clearfix)
				$result .= '<div class="clearfix"></div>' . "\n"; // fix for IE7
		}
		return $result;
	}

	function get_positions($pos_names, $spacer = '', $spacer_down = true, $clearfix = true, $id = '', $tdgap = false) {
		$result = '';
		$positions = array();
		for ($i = 0, $len = count($pos_names); $i < $len; $i++)
			if ($this->modcount($pos_names[$i]))
				$positions[] = $pos_names[$i];

		if (empty($positions))
			return;

		$count = count($positions);

		if ($spacer != '' && !$spacer_down)
			$result .= '<div id="' . $spacer . '"></div>' . "\n";

		if ($count > 1)
			$result .= '<table ' . ($id == '' ? '' : ' id="' . $id . '"') . 'cellspacing="0" cellpadding="0" width="100%"><tr>' . "\n";

		if ($tdgap === false)
			$tdgap = '<td class="tdgap"></td>' . "\n";

		$first = true;
		foreach ($positions as $position_name) {
			if ($first)
				$first = false;
			else
				$result .= $tdgap;

			if ($count > 1)
				$result .= '<td valign="top"' . $this->td_width($position_name) . '>' . "\n";

			$result .= $this->get_position($position_name, true, $clearfix);

			if ($count > 1)
				$result .= '</td>' . "\n";
		}

		if ($count > 1)
			$result .= '</tr></table>' . "\n";

		if ($spacer != '' && $spacer_down)
			$result .= '<div id="' . $spacer . '"></div>' . "\n";

		return $result;
	}

	function load_menu($menu_name, &$out_head_tags, &$out_js) {
		$user =& JFactory::getUser();
		$user_access = (int) $user->get('aid', 0);

		$contentConfig = &JComponentHelper::getParams( 'com_content' );
		$shownoauth = $contentConfig->get('shownoauth');

		$db =& JFactory::getDBO();
		$db->setQuery( sprintf(
			"SELECT * FROM #__menu WHERE menutype=%s AND published='1' %s ORDER BY ordering",
			$db->Quote($menu_name),
			//$shownoauth ? "" : "AND access <= '$user_access'"
			$shownoauth ? "" : "AND access >= '$user_access'"//j17
		) );
		$menu = $db->loadObjectList('id');

		// initialize menu tree
		$menu_base = array();
		if (!empty($menu))
		foreach ($menu as $k => $mitem) {
			$mi = $this->load_menu_item($mitem);
			$menu[$k]->is_active = $mi['selection'] > 0;
			$menu[$k]->selection = $mi['selection'];
			$menu[$k]->type = $mi['type'];
			$menu[$k]->link = $mi['link'];
			//$menu[$k]->name = $mi['name'];
			$menu[$k]->title = $mi['title'];//j17
			$menu[$k]->name = $mi['name'];
			$menu[$k]->image = $mi['image'];
			$menu[$k]->sub_menu_items = array();
		}

		// load Joomla! content menu items
		if ($this->cnt_menus) {
			require_once(dirname(__FILE__) . '/menuloader.content.php');
			$cnt_loader = new BtMenuCntLoader();
			$cnt_menu = array();
			foreach ($menu as $k => $mi) {
				if ($mi->link != '' && $mi->link{0} == ':' && $mi->type == 'link') {
					$link = trim(strtolower($mi->link));
					if (substr($link, 0, 5) == ':cnt:') {
						$menu[$k]->link = '#';
						$menu[$k]->href = 'href="#"';

						$new_menu = $cnt_loader->load($k, $link);
						foreach ($new_menu as $k => $v)
							$cnt_menu[$k] = $v;
					}
				}
			}

			foreach ($cnt_menu as $k => $v)
				$menu[$k] = $v;
		}

		// load virtuemart menu items
		if ($this->virtuemart) {
			if (!defined('_VM_PARSER_LOADED')) {
				$ini_filename = dirname(__FILE__) . '/../../components/com_virtuemart/virtuemart_parser.php';
				if (file_exists($ini_filename))
					require_once($ini_filename);
			}

			if (defined('_VM_PARSER_LOADED')) {
				require_once(dirname(__FILE__) . '/menuloader.virtuemart.php');
				$vm_loader = new BtMenuVMLoader();
				$vm_menu = array();
				foreach ($menu as $k => $mi) {
					if ($mi->link != '' && $mi->link{0} == ':' && $mi->type == 'link') {
						$link = trim(strtolower($mi->link));
						if (substr($link, 0, 4) == ':vm:') {
							$menu[$k]->link = '#';
							$menu[$k]->href = 'href="#"';

							$new_menu = $vm_loader->load($k, $link);
							foreach ($new_menu as $k => $v)
								$vm_menu[$k] = $v;
						}
					}
				}

				foreach ($vm_menu as $k => $v)
					$menu[$k] = $v;
			}
		}

		// set tree hierarchy
		foreach ($menu as $k => $mitem) {
			if ($mitem->parent_id == '1') //j17 1 until 0 of j15
				$menu_base[] = $k;
			//else if (isset($menu[$mitem->parent]))
			else if (isset($menu[$mitem->parent_id]))//j17
				//$menu[$mitem->parent]->sub_menu_items[] = $k;
				$menu[$mitem->parent_id]->sub_menu_items[] = $k;//j17
		}

		// prepare javascript code
		$out_head_tags = array();
		$out_js = '';
		if (!empty($menu_base)) {
			$stack = array('base' => $menu_base);
			while (!empty($stack)) {
				reset($stack);
				list($base, $items) = each($stack);
				array_shift($stack);

				foreach ($items as $item) {
					$mi = &$menu[$item];

					if (!empty($mi->sub_menu_items))
						$stack = array_merge($stack, array('cmi' . $item => $mi->sub_menu_items));
					if (!empty($mi->image))
						//$mi->name = $mi->image . ' ' . $mi->name;
						$mi->title = $mi->image . ' ' . $mi->title;//j17

					if ($base == 'base') {
						$mi->head_id = 'cmi' . $item;
						//$mi->full_link = $mi->href != '' ? '<a ' . $mi->href . '>' . $mi->name . '</a>' : $mi->name;
						$mi->full_link = $mi->href != '' ? '<a ' . $mi->href . '>' . $mi->title . '</a>' : $mi->title;//j17
						$out_head_tags[] = $mi;
						$out_js .= sprintf(
							"document['cmenu_items'].push({id: '%s', type: '%s', link: '%s', selection: %u});\n",
							'cmi' . $item,
							json_esc($mi->type),
							json_esc(str_replace('&amp;', '&', $mi->link)),
							$mi->selection
						);
					}
					else {
						$out_js .= sprintf(
							"document['cmenu_items'].push({id: '%s', parent_id: '%s', type: '%s', link: '%s', caption: '%s', selection: %u});\n",
							'cmi' . $item,
							$base,
							json_esc($mi->type),
							json_esc(str_replace('&amp;', '&', $mi->link)),
							//json_esc(str_replace('&amp;', '&', $mi->name)),
							json_esc(str_replace('&amp;', '&', $mi->title)),//j17
							$mi->selection
						);
					}
				}	
			}
		}

	}

	function load_menu_item($item) {
		$result = array(
			'type' => 'text', // text, link, link_new, link_popup, separator
			//'name' => $item->name,
			'title' => $item->title,//j17
			'link' => '',
			'href' => '',
			'image' => '',
			'selection' => 0, // 0 = none, 1 = parent, 2 = current
		);

		// Menu Link is a special type that is a link to another item
		if ($item->type == 'menulink') {
			$target_id = 0;

			if (!empty($item->params)) {
				$source_params = new JParameter($item->params);
				$target_id = $source_params->get('menu_item', 0);
			}

			if ($target_id == 0 && preg_match('/Itemid=([0-9]+)/', $item->link, $m))
				$target_id = intval($m[1]);

			if ($target_id > 0) {
				$menu = &JSite::getMenu();
				if ($tmp = $menu->getItem($target_id))
					$item = $tmp;
			}
		}

		static $path = false;
		if ($path === false) {
			$menu = &JSite::getMenu();
			$active = $menu->getActive();
			$path = isset($active) ? array_reverse($active->tree) : null;
		}

		if (!is_array($path) || empty($path))
			{ } // ignore cases
		else if ($path[0] == $item->id)
			$result['selection'] = 2;
		else if (in_array($item->id, $path))
			$result['selection'] = 1;

		jimport( 'joomla.html.parameter' );//j17
		$iParams = new JParameter($item->params);
		if ($iParams->get('menu_image') && $iParams->get('menu_image') != -1)
			$result['image'] = '<img src="'.JURI::base(true).'/'.$iParams->get('menu_image').'" alt="" border="0" />';//j17
			//$result['image'] = '<img src="'.JURI::base(true).'/images/stories/'.$iParams->get('menu_image').'" alt="" border="0" />';//j17

		switch ($item->type) {
			case 'separator' :
				$result['type'] = 'separator';
				break;

			case 'url' :
				if ((strpos($item->link, 'index.php?') !== false) && (strpos($item->link, 'Itemid=') === false)) {
					$item->url = $item->link.'&amp;Itemid='.$item->id;
				} else {
					$item->url = $item->link;
				}
				break;

			default :
				$router = JSite::getRouter();
				$item->url = $router->getMode() == JROUTER_MODE_SEF ? 'index.php?Itemid='.$item->id : $item->link.'&Itemid='.$item->id;
				break;
		}

		// Print a link if it exists
		if ($item->type != 'separator' && $item->url != null)
		{
			// Handle SSL links
			$iSecure = $iParams->def('secure', 0);
			if ($item->home == 1) {
				$item->url = JURI::base();
			} elseif (strcasecmp(substr($item->url, 0, 4), 'http') && (strpos($item->link, 'index.php?') !== false)) {
				$item->url = JRoute::_($item->url, true, $iSecure);
			} else {
				$item->url = str_replace('&', '&amp;', $item->url);
			}

			$result['link'] = $item->url;

			switch ($item->browserNav) {
				case 1:
					// _blank
					$result['href'] = 'href="'.$item->url.'" target="_blank"';
					$result['type'] = 'link_new';
					break;

				case 2:
					// window.open
					$attribs = 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes';
					$link = str_replace('index.php', 'index2.php', $item->url);
					$result['href'] = 'href="'.$link.'" onclick="window.open(this.href,\'targetWindow\',\''.$attribs.'\');return false;"';
					$result['type'] = 'link_popup';
					$result['link'] = $link;
					break;

				case 0:
				default:
					// _top
					$result['href'] = 'href="'.$item->url.'"';
					$result['type'] = 'link';
					break;
			}

			if ($result['type'] == 'text')
				$result['type'] = 'link';
		}

		return $result;
	}

}


/**
 * Escapes strings to be used by JavaScript
 * 
 * @version 1.1.0.20070709
 * @author Alex Stylianos
 * @copyright Creative Pulse 2007
 * @link http://www.creativepulse.eu
 */
if (!function_exists('json_esc')) {
	function json_esc($input, $esc_lt_gt = true) {
		$result = '';
		$input = (string) $input;
		$conv = array( "'" => "'", '"' => '"', '&' => '&', '\\' => '\\', "\n" => 'n', "\r" => 'r', "\t" => 't', "\b" => 'b', "\f" => 'f' );
	
		if ($esc_lt_gt)
			$conv = array_merge($conv, array( '<' => 'u003C', '>' => 'u003E' ));
	
		for ($i = 0, $len = strlen($input); $i < $len; $i++)
			$result .= isset($conv[$input{$i}]) ? '\\' . $conv[$input{$i}] : $input{$i};
	
		return $result;
	}
}

global $tpl;
$tpl = new TplBtPromote();

?>